'use strict';

const express = require('express');

const app = {
    use: jest.fn(),
    get: jest.fn(),
    listen: jest.fn(),
}
jest.doMock('express', () => {
    return () => {
        return app;
    };
});

const serve = require('../serve.js');
const path = require('path');

console.error = jest.fn(error => {
    throw new Error(error);
});

beforeEach(() => {
    express.mockClear();
});

it('todo', () => {
    const loaderDir = path.join(__dirname, 'fixtures/loader/');

    return serve.command(loaderDir + 'openapi.yaml', {}).then(() => {
        expect(app.get).toHaveBeenCalledWith('/assets/redoc', 'foo');
        expect(app.get).toHaveBeenCalledWith('/spec.json', 'foo');
        expect(app.use).toHaveBeenCalledWith('/', '<html>');
        expect(app.listen).toHaveBeenCalledWith(5000);

        // expect(app.get.mock.calls[0][0]).toEqual('/assets/redoc');
        // expect(app.get.mock.calls[0][1]).toEqual('other');
    });
});
